#include <iostream>
#include "catraca.h"
#include "nodo.h"
#include "nodo.cc"


using json = nlohmann::json;


Catraca::Catraca()
{
    serverIP = "";
    serverPort = 0;
    lista = NULL;
    status = 0;
}

Catraca::~Catraca()
{
    //Apagar a lista
}

int Catraca::getStatus()
{
    return status;
}


string Catraca::getServerIP()
{
    return serverIP;
}

int Catraca::getServerPort()
{
    return serverPort;
}

void Catraca::setServerIP(string serverIP)
{
    serverIP = serverIP;
}

void Catraca::setServerPort(int serverPort)
{
    serverPort = serverPort;
}

void Catraca::upServerStudentCount(int contagem)
{
    json j;
    j["v"] = contagem;
    string j2 = j.dump();
    string ep = serverIP+":"+to_string(serverPort)+"/contador";
    RestClient::Response r = RestClient::post(ep, "application/json", j2);
    if (r.code != 201)
    {
        cout << "Nao foi possivel alterar a contagem no servidor" << endl;
        //TODO Colocar na mesma lista da atualizacao do credito do usuario quando nao  possivel alterar o credito no servidor?
    }
}

/*
void Catraca::setList(List* lista)
{
	lista = lista;
}
*/

void Catraca::start()// incializa a placa e requisita todas as transao do servidor
{

    cout << "Digite o ip do servidor" << endl; //pede o ip do servidor
    cin >> serverIP;

    cout << "Digite a porta" << endl; // pede a porta necessaria
    cin >> serverPort;

    string ep = serverIP+":"+to_string(serverPort);
    cout << "Conectando a " << ep << endl;
    RestClient::Response r = RestClient::get(ep+"/transaction");
    if (r.code == 200)// testa a reposta para saber se conseguiiu conexo com o servidor
    {
        cout << "Inicializando..." << endl;
        cout << (Node<int>*)NULL << endl;
        List* l = new List(); // cria que recebe todos os estudantes
        auto j = json::parse(r.body);// tranforma a string recebido em um json que a biblioteca consegue trabalhar
        for (auto& element : j)  // ":" sobrecarga de operador da biblioteca json para criar um iterator e varrer o json
        {
            json j2 = element;
            Student* s = new Student; // cria um novo objeto studente que recebe os valores das transaes
            s->setCardID(element["cardID"]);
            s->setUserId(element["user_id"]);
            s->insertEvent(new Node<int>( new int(element["event"]))); // cria um novo evento para guardar a movimentao de crdito
            s->setMatricula(element["matricula"]);
            s->setSalt(element["salt"]);
            s->setPassword(element["n_password_hash"]);
            l->append(s);// adiciona a lista
        }
        lista = l;
        listaDentro = new List;// cria a lista que vai guardar os usurios que esto dentro do ru
        listaAtualiza = new List;// cria a lista que vai guardar os usurios que esto esperando para serem atualizados no servidor
        status = 1;
        //lista->print();
    }
    else
    {
        cout << "erro na inicializacao! codigo do erro :" << r.code << endl;
        status = -1;
    }
}

void Catraca::run()// roda o programa que libera a catraca
{
    string cartao;
    Node<Student> *tmp;
    int c;
    while(1)
    {
        cout << string( 100, '\n' );
        cout << endl << "Status atual dos usuarios fora do RU" << endl ;
        lista->print();
        listaAtualiza->print();
        cout << endl << "tem " << listaDentro->getContador() << " pessoas dentro do RU. pessoas dentro do RU:" << endl;
        listaDentro->print();
        cout << "selecione 1 para a catraca de entrada ou 2 para a catraca de saida: ";
        cin >> c;
        cout << "Digite o carto" << endl;
        cin >> cartao;
        transform(cartao.begin(), cartao.end(), cartao.begin(),::toupper); //seta todos os caracteres para maiusculo
        switch(c)
        {
        case 1:
            if (tmp = lista->find(cartao))// procura o estudanta na lista atualizada
            {
                cout << "Pessoa encontrada" << endl;
                if (tmp->getData()->getCredito() > 0)// verifica se o crdito  suficiente
                {
                    tmp->getData()->insertEvent(new Node<int>( new int(-1)));// insere um novo evento com o valor de -1 por estar entrando no ru
                    tmp->getData()->incContEvent();
                    cout << "AUTORIZADO... novo credito (na placa): " << tmp->getData()->getCredito() << endl;
                    listaDentro->append(lista->removeStudent(tmp)->getData());
                    delete tmp;
                }
                else
                {
                    cout << "Creditos insuficientes ou j est dentro do RU" << endl;
                }
            }
            else if (tmp = listaAtualiza->find(cartao))// procura o estudanta na lista a ser atualizada o resto  igual ao anterior
            {
                cout << "Pessoa encontrada na lista atualiza" << endl;
                if (tmp->getData()->getCredito() > 0)
                {
                    tmp->getData()->insertEvent(new Node<int>( new int(-1)));
                    tmp->getData()->incContEvent();
                    cout << "AUTORIZADO... novo credito (na placa): " << tmp->getData()->getCredito() << endl;
                    listaDentro->append(listaAtualiza->removeStudent(tmp)->getData());
                    delete tmp;
                }
                else
                {
                    cout << "Creditos insuficientes ou j est dentro do RU" << endl;
                }
            }
            else
            {
                cout << "Pessoa no encontrada" << endl;
            }
            break;
        case 2:
            if (tmp = listaDentro->find(cartao))
            {
                cout << "Saida registrada" << endl;
                    cout << "credito atual na placa: " << tmp->getData()->getCredito() << endl;
                    listaAtualiza->append(listaDentro->removeStudent(tmp)->getData());
                    delete tmp;
                    if(atualizaservidor())
                    {

                        cout << endl << "servidor atualizado" << endl;
                    }
                    else
                    {
                        cout << endl << "servidor atualizado" << endl;
                    }
            }
            break;
        default:
            break;
        }
    }


}

unsigned int Catraca::atualizaservidor()// funo de varedura da lista dentro e atualizando os students
{
    Node<Student> *tmp2,*tmp = listaAtualiza->getHead();
    unsigned int aux = 1;
    while(aux && tmp)
    {
        if(aux = tmp->getData()->atualizaEvents( serverIP, serverPort))
        {
            tmp2 = tmp;
            tmp = tmp->getNext();
            lista->append(listaAtualiza->removeStudent(tmp2)->getData());
        }
    }
    if(aux)// atualiza contador
    {
        json j;
        j["v"] = listaDentro->getContador();
        string ep = serverIP+":"+to_string(serverPort)+"/contador";
        RestClient::Response r = RestClient::post(ep, "application/json", j.dump());
        if (r.code != 201)
        {
            cout << "Nao foi possivel alterar a contagem no servidor" << endl;
        }
    }
    return aux;
}
