#include <iostream>
#include "list.h"
#include "nodo.h"
#include "nodo.cc"

List::List()
{
    head = NULL;
    tail = NULL;
    contador = 0;
}

List::~List()
{
    head = NULL;
    delete head;
}

int List::getContador()
{
    return contador;
}

Node<Student>* List::find(string s)
{
    Node<Student> *tmp = head;
    int aux = 0;


    while (tmp != NULL && aux == 0)
    {
        if (tmp->getData()->getCardID() == s)
            aux=1;
        else
            tmp = tmp->getNext();
    }

    return tmp;

}

void List::print()
{

    Node<Student> *tmp = head;

    if ( tmp == NULL )
    {
        cout << "EMPTY" << endl;
        return;
    }

    if ( tmp->getNext() == NULL )
    {
        cout << "User " << tmp->getData()->getUserID() << " Credito "  << tmp->getData()->getCredito() << endl;
    }
    else
    {
        do
        {
            cout << "User " << tmp->getData()->getUserID() << " Credito "  << tmp->getData()->getCredito() << endl;
            tmp = tmp->getNext();
        }
        while ( tmp != NULL );


    }
}
void List::append(Student* data)
{
    int user_id = data->getUserID();
    int up = 1;
    Node<int> *aux;
    Node<Student> *tmp = head;
    if (tmp == NULL)
    {
        Node<Student>* newNode = new Node<Student>();
        newNode->setData(data);
        newNode->setNext(NULL);
        newNode->setPrev(NULL);
        head = newNode;
        tail = newNode;
        contador++;
    }
    else
    {
        while (tmp != tail && up != 0)
        {
            if (tmp->getData()->getUserID() == user_id)
            {
                while((aux = data->removeFristNode()) != NULL)
                {
                    tmp->getData()->insertEvent(aux);
                    up = 0;
                }
                delete data;
            }
            else
            {
                tmp = tmp->getNext();
            }

        }
        if (up == 1)
        {
            if (tmp->getData()->getUserID() == user_id)
            {

                while((aux = data->removeFristNode()) != NULL)
                {
                    tmp->getData()->insertEvent(aux);
                }
                delete data;

            }
            else
            {
                Node<Student>* newNode = new Node<Student>();
                newNode->setData(data);
                newNode->setNext(NULL);
                newNode->setPrev(tmp);
                tail = newNode;
                tmp->setNext(newNode);
                contador++;
            }
        }
    }

}


Node<Student>* List::getHead()
{
    return head;
}

Node<Student>* List::getTail()
{
    return tail;
}

Node<Student>* List::removeStudent(Node<Student> *n)
{
    Node<Student> *p,*q;
    if(n != tail && n != head)
    {
        p = n->getPrev();
        q = n->getNext();
        q->setPrev(p);
        p->setNext(q);
    }
    else if(n != tail)
    {
        q = n->getNext();
        q->setPrev(NULL);
        head = q;
    }
    else if(n != head)
    {
        p = n->getPrev();
        p->setNext(NULL);
        tail = p;
    }
    else
    {
        tail = NULL;
        head = NULL;
    }
    contador--;
    return n;
}
