#include "student.h"
#include "nodo.h"
#include "nodo.cc"

Student::Student()
{
    credito = 0;
    //studentIn = false;
    cardID = "";
    userID = 0;
    matricula = "";
    password_hash = "";
    salt = "";
    head = NULL;
    tail = NULL;
    contEvent = 0;
}

string Student::getCardID()
{
    return cardID;
}

int Student::getUserID()
{
    return userID;
}

int Student::getCredito()
{
    return credito;
}

string Student::getPassword()
{
    return password_hash;
}

string Student::getMatricula()
{
    return matricula;
}

string Student::getSalt()
{
    return salt;
}

void Student::setPassword(string s)
{
    password_hash = s;
}

void Student::setMatricula(string s)
{
    matricula = s;
}

void Student::setSalt(string s)
{
    salt = s;
}

void Student::setCardID(string s)
{
    cardID = s;
}

void Student::setUserId(int i)
{
    userID = i;
}

void Student::setCredito(int i)
{
    credito = i;
}

Node<int>* Student::getHead()
{
    return head;
}

Node<int>* Student::getTail()
{
    return tail;
}

void Student::insertEvent(Node<int>* n)
{
    if(head == NULL && tail == NULL)
    {
        tail = n;
        head = n;

        credito = (*n->getData());
    }
    else
    {
        tail->setNext(n);
        n->setPrev(tail);
        tail = n;
        tail->setNext(NULL);
        credito += (*n->getData());
    }

}

Node<int>* Student::removeFristNode()
{
    Node<int> *n, *q;
    n = head;
    if(head == NULL)
    {
        return NULL;
    }
    else if(n != tail)
    {
        q = n->getNext();
        q->setPrev(NULL);
        head = q;
    }
    else
    {
        tail = NULL;
        head = NULL;
    }
    return n;
}

void Student::incContEvent()
{
    contEvent++;
}

unsigned int Student::atualizaEvents(string serverIP, unsigned int serverPort)
{
    unsigned int c;
    string ep;
    Node<int> *aux = this->tail;
    for(c=1; c < this->contEvent; c++)
    {
        aux = tail->getPrev();
    }
    while(contEvent && c)
    {
        ep = serverIP+":"+to_string(serverPort)+"/transaction/"+to_string(userID);
        RestClient::Response r = RestClient::post(ep, "application/json", "{\"event_id\": " + to_string((*aux->getData())) + "}");

        if (r.code == 201)
        {
            aux = aux->getNext();
            contEvent--;
            c = 1;
        }
        else
        {
            c = 0;
        }
    }

    return c;


}

